{

    Tool to stream MIDI data over TCP/IP

    Copyright (C) 2003 .. 2008 Blue Hell / Jan Punter :: J.Punter@iaf.nl

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; Version 2 of the License only.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Modification history :

    2003-02-22

      - ported to D7 and published


    2008-02-01

      - removed some dialogs and put settings into main scren instead.

      - removed the memory monitor, it was buggy and no good on XP

}

unit FrmClientServer;

{$WARN UNSAFE_TYPE OFF}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ScktComp, FrmAbout, IniFiles, Globals, ExtCtrls, MidiType, MidiOut,
  MidiIn, StdCtrls, Buttons, Data, ComCtrls, mmSystem, VTerm, HiResTim,
  WinSock, Sockets, IPHelpers, WinSockErrors;

type
  TFormServerMain = class(TForm)
    MainMenu: TMainMenu;
    MenuItemFile: TMenuItem;
    MenuItemExit: TMenuItem;
    MenuItemHelp: TMenuItem;
    MenuItemAbout: TMenuItem;
    TimerRx: TTimer;
    TimerTx: TTimer;
    MidiInput: TMidiInput;
    MidiOutput: TMidiOutput;
    ClientSocket: TClientSocket;
    ServerSocket: TServerSocket;
    MenuItemConnect: TMenuItem;
    TimerMidi: TTimer;
    TimerOf: TTimer;
    TimerUf: TTimer;
    PanelInfo: TPanel;
    PanelMain: TPanel;
    PageControlMain: TPageControl;
    TabSheetConnections: TTabSheet;
    PanelConnectionsLower: TPanel;
    PanelConnections: TPanel;
    ListBoxConnections: TListBox;
    PanelConnectionsControl: TPanel;
    SpeedButtonDisconnect: TSpeedButton;
    SpeedButtonConnect: TSpeedButton;
    TabSheetChat: TTabSheet;
    SplitterChat: TSplitter;
    PanelChatSend: TPanel;
    PanelChatIn: TPanel;
    MemoChatSend: TMemo;
    PanelChatControl: TPanel;
    SpeedButtonClearLowerChat: TSpeedButton;
    SpeedButtonClearUpperChat: TSpeedButton;
    SpeedButtonSendChat: TSpeedButton;
    PanelChatOut: TPanel;
    ScrollBoxChat: TScrollBox;
    VTermChat: TVTerm;
    TabSheetSettings: TTabSheet;
    PanelSettings: TPanel;
    GroupBoxTcp: TGroupBox;
    Label1: TLabel;
    LabelServerName: TLabel;
    EditIpPort: TEdit;
    CheckBoxIsServer: TCheckBox;
    EditServerName: TEdit;
    CheckBoxAutoStart: TCheckBox;
    CheckBoxDisableNagle: TCheckBox;
    BitBtnApplyIp: TBitBtn;
    BitBtnCancelIp: TBitBtn;
    GroupBoxMidi: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    ComboBoxInputs: TComboBox;
    ComboBoxOutputs: TComboBox;
    EditBufferTime: TEdit;
    EditBufferResolution: TEdit;
    BitBtnApplyMidi: TBitBtn;
    BitBtnCancelMidi: TBitBtn;
    GroupBoxChat: TGroupBox;
    Label2: TLabel;
    EditYourName: TEdit;
    BitBtnApplyChat: TBitBtn;
    BitBtnCancelChat: TBitBtn;
    TabSheetMonitor: TTabSheet;
    PanelMonitorControl: TPanel;
    SpeedButtonClearMonitor: TSpeedButton;
    CheckBoxMonitoring: TCheckBox;
    PanelMonitor: TPanel;
    ScrollBoxMonitor: TScrollBox;
    VTermMonitor: TVTerm;
    PanelTx: TPanel;
    PanelRx: TPanel;
    PanelUf: TPanel;
    PanelOf: TPanel;
    procedure MenuItemExitClick(Sender: TObject);
    procedure TimerRxTimer(Sender: TObject);
    procedure TimerTxTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MidiInputMidiInput(Sender: TObject);
    procedure SpeedButtonClearMonitorClick(Sender: TObject);
    procedure SpeedButtonClearUpperChatClick(Sender: TObject);
    procedure SpeedButtonClearLowerChatClick(Sender: TObject);
    procedure SpeedButtonSendChatClick(Sender: TObject);
    procedure ClientSocketConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketLookup(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketConnecting(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ClientSocketRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure ServerSocketAccept(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocketClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocketClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocketClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure ServerSocketClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocketListen(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure MenuItemAboutClick(Sender: TObject);
    procedure MenuItemConnectClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CheckBoxMonitoringClick(Sender: TObject);
    procedure SpeedButtonDisconnectClick(Sender: TObject);
    procedure TimerMidiTimer(Sender: TObject);
    procedure VTermMonitorCursorMoved(aSender: TObject; aCol, aRow: Integer);
    procedure VTermMonitorDimChanged(aSender: TObject; aCol, aRow: Integer);
    procedure FormResize(Sender: TObject);
    procedure VTermChatCursorMoved(aSender: TObject; aCol, aRow: Integer);
    procedure VTermChatDimChanged(aSender: TObject; aCol, aRow: Integer);
    procedure TimerOfTimer(Sender: TObject);
    procedure TimerUfTimer(Sender: TObject);
    procedure SpeedButtonConnectClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ChatSettingsChanged(Sender: TObject);
    procedure MidiSettingsChanged(Sender: TObject);
    procedure BitBtnApplyChatClick(Sender: TObject);
    procedure BitBtnCancelChatClick(Sender: TObject);
    procedure BitBtnApplyIpClick(Sender: TObject);
    procedure BitBtnCancelIpClick(Sender: TObject);
    procedure BitBtnApplyMidiClick(Sender: TObject);
    procedure BitBtnCancelMidiClick(Sender: TObject);
    procedure IpSettingsChanged(Sender: TObject);
  Private
      FMidiInitialized    : Boolean;
      FChatChanged        : Boolean;
      FMidiChanged        : Boolean;
      FIpChanged          : Boolean;
      FMidiIn             : String;
      FMidiOut            : String;
      FPreMidiIn          : String;
      FPreMidiOut         : String;
      FMidiInOpen         : Boolean;
      FMidiOutOpen        : Boolean;
      FBufferTime         : Cardinal;
      FBufferResolution   : Cardinal;
      FPort               : Integer;
      FIsServer           : Boolean;
      FIsConnected        : Boolean;
      FServerName         : String;
      FOrigCaption        : String;
      FMonitoring         : Boolean;
      FYourName           : String;
      FConnections        : TStringList;
      FLockConnectUpdates : Integer;
      FStartTime          : DWord;
      FMidiOutBuffer      : TTimedBuffer;
      FAutoStart          : Boolean;
      FDisableNagle       : Boolean;
  Private
    Procedure   InitMidi;
    Procedure   SetChatChanged     ( aValue: Boolean);
    Procedure   SetMidiChanged     ( aValue: Boolean);
    Procedure   SetIpChanged       ( aValue: Boolean);
    Procedure   SetMidiIn          ( Const aValue: String);
    Procedure   SetMidiOut         ( Const aValue: String);
    Procedure   SetMidiInOpen      ( aValue: Boolean);
    Procedure   SetMidiOutOpen     ( aValue: Boolean);
    Procedure   SetBufferTime      ( aValue: Cardinal);
    Procedure   SetBufferResolution( aValue: Cardinal);
    procedure   SetPort            ( aValue: Integer);
    Procedure   SetIsServer        ( aValue: Boolean);
    Procedure   SetIsConnected     ( aValue: Boolean);
    procedure   SetServerName      ( const aValue: string);
    procedure   SetYourName        ( const aValue: string);
    Procedure   SetMonitoring      ( aValue: Boolean);
    procedure   SetAutoStart       ( aValue: Boolean);
    procedure   SetDisableNagle    ( aValue: Boolean);
    Procedure   UpdateCaption;
    Procedure   LockConnectUpdates;
    Procedure   UnlockConnectUpdates;
    Procedure   MidiOutOverflow( aSender: TObject);
    Procedure   MidiOutUnderflow( aSender: TObject);
    Procedure   MidiOutComplete( aData: TData);
  Private
    Procedure   ApplyChatSettings;
    Procedure   CancelChatSettings;
    Procedure   ApplyIpSettings;
    Procedure   CancelIpSettings;
    Procedure   ApplyMidiSettings;
    Procedure   CancelMidiSettings;
  Protected
    Procedure   DoConnect( aValue: Boolean);
    Procedure   SetNagleOption( aSock: TSocket);
    Procedure   HandleIpDecoded( aData: TData);                         Virtual;
    Procedure   SetIpSettings;
    Procedure   ShowMonitorData   ( Const S: String);
    Procedure   ShowMonitorDataFmt( Const S: String; Const aFormat: Array Of Const);
    Function    FormatConnectInfo( aSocket: TCustomWinSocket): String;
    Procedure   AddConnection( aSocket: TCustomWinSocket);
    Procedure   RemConnection( aSocket: TCustomWinSocket);
    Procedure   UpdateConnections;
    Procedure   DisConnectClient( Const aConnectInfo: String);
    Function    GetRelativeTime: Word;
  Public
    Procedure   SaveIni; Virtual;
    Procedure   LoadIni; Virtual;
    Procedure   SignalRx;
    Procedure   SignalTx;
    Procedure   SignalOf;
    Procedure   SignalUf;
    Procedure   ShowTimeData( aData: TData);
    Procedure   ShowMidiData( aData: TData);
    Procedure   SendChatData( Const S: String);                        Overload;
    Procedure   SendChatDataFmt( Const aFormat: String; Const anArgs: Array Of Const);
    Procedure   SendChatData;                                          Overload;
    Procedure   SendTimeFiller;
    Procedure   ShowChatData   ( aData: TData);
    Procedure   SendIpData     ( aData: TData);                          Virtual;
    Procedure   DecodeIpData   ( aDecoder: TDecoder; aData: TData);
  Public
    property    ChatChanged      : Boolean  read FChatChanged      write SetChatChanged;
    property    MidiChanged      : Boolean  read FMidiChanged      write SetMidiChanged;
    property    IpChanged        : Boolean  read FIpChanged        write SetIpChanged;
    property    MidiIn           : String   read FMidiIn           write SetMidiIn;
    property    MidiOut          : String   read FMidiOut          write SetMidiOut;
    property    MidiInOpen       : Boolean  read FMidiInOpen       write SetMidiInOpen;
    property    MidiOutOpen      : Boolean  read FMidiOutOpen      write SetMidiOutOpen;
    property    BufferTime       : Cardinal read FBufferTime       write SetBufferTime;
    property    BufferResolution : Cardinal read FBufferResolution write SetBufferResolution;
    property    Port             : Integer  read FPort             write SetPort;
    property    IsServer         : Boolean  read FIsServer         write SetIsServer;
    property    IsConnected      : Boolean  read FIsConnected      write SetIsConnected;
    property    ServerName       : String   read FServerName       write SetServerName;
    property    YourName         : String   read FYourName         write SetYourName;
    property    Monitoring       : Boolean  read FMonitoring       write SetMonitoring;
    property    AutoStart        : Boolean  read FAutoStart        write SetAutoStart;
    property    DisableNagle     : Boolean  read FDisableNagle     write SetDisableNagle;
  end;

var
  FormServerMain: TFormServerMain;

implementation

{$R *.DFM}

// User area

{$WARN UNSAFE_TYPE OFF}
{$WARN UNSAFE_CODE OFF}
{$WARN UNSAFE_CAST OFF}



    Function CheckCardinal( anEdit: TEdit): Cardinal;
    Var
      N : Int64;
      C : Integer;
    Begin
      Result := 0;
      Val( anEdit.Text, N, C);
      If C = 0
      Then Begin
        If N < Int64( 65536) * 65536
        Then Result := N
        Else Abort;
      End
      Else Begin
        anEdit.SetFocus;
        Abort;
      End;
    End;


    Procedure   TFormServerMain.InitMidi;
    Var
      i       : UINT;
      aInCaps : TMidiInCaps;
      aOutCaps: TMidiOutCaps;
    Begin
      If Not FMidiInitialized
      Then Begin
        // Inputs
        With ComboBoxInputs
        Do Begin
          Clear;
          If MidiInGetNumDevs > 0
          Then Begin
            For i := 0 To MidiInGetNumDevs - 1
            Do Begin
              MidiInGetDevCaps( i, @ aInCaps, SizeOf( aInCaps));
              Items.Add( StrPas( aInCaps.szPName));
            End;
          End;
        End;
        // Outputs
        With ComboBoxOutputs Do
        Begin
          Clear;
          MidiOutGetDevCaps( MIDI_MAPPER, @ aOutCaps, SizeOf( aOutCaps));
          Items.Add( StrPas( aOutCaps.szPName));
          If MidiOutGetNumDevs > 0
          Then Begin
            For i := 0 To MidiOutGetNumDevs - 1
            Do Begin
              MidiOutGetDevCaps( i, @ aOutCaps, SizeOf( aOutCaps));
              Items.Add( StrPas( aOutCaps.szPName));
            End;
          End;
        End;
        // Flag initialization
        FMidiInitialized := True;
      End;
    End;

    Procedure   TFormServerMain.SetChatChanged( aValue: Boolean);
    begin
      FChatChanged := aValue;
      BitBtnApplyChat .Enabled := aValue;
      BitBtnCancelChat.Enabled := aValue;
    end;

    Procedure   TFormServerMain.SetMidiChanged( aValue: Boolean);
    begin
      FChatChanged := aValue;
      BitBtnApplyMidi .Enabled := aValue;
      BitBtnCancelMidi.Enabled := aValue;
    end;

    Procedure   TFormServerMain.SetIpChanged ( aValue: Boolean);
    begin
      FChatChanged := aValue;
      BitBtnApplyIp  .Enabled := aValue;
      BitBtnCancelIp .Enabled := aValue;
      LabelServerName.Visible := not CheckBoxIsServer.Checked;
      EditServerName .Visible := not CheckBoxIsServer.Checked;
    end;

    Procedure   TFormServerMain.SetMidiIn( Const aValue: String);
    Var
      WasOpen : Boolean;
    Begin
      WasOpen := MidiInOpen;
      If WasOpen
      Then MidiInOpen := False;
      if aValue <> ''
      then begin
        Try
          With MidiInput
          Do ProductName := aValue;
          If WasOpen
          Then MidiInOpen := True;
          FMidiIn := aValue;
        Except
          On E:Exception
          Do ShowMessageFmt( 'Could not open midi in port : %s', [ E.Message]);
        End;
      end
      else FMidiIn := '';
    End;

    Procedure   TFormServerMain.SetMidiOut( Const aValue: String);
    Var
      WasOpen : Boolean;
    Begin
      WasOpen := MidiOutOpen;
      If WasOpen
      Then MidiOutOpen := False;
      if aValue <> ''
      then begin
        Try
          With MidiOutput
          Do ProductName := aValue;
          If WasOpen
          Then MidiOutOpen := True;
          FMidiOut := aValue;
        Except
          On E:Exception
          Do ShowMessageFmt( 'Could not open midi in port : %s', [ E.Message]);
        End;
      end
      else FMidiOut := '';
    End;

    Procedure   TFormServerMain.SetMidiInOpen( aValue: Boolean);
    Begin
      If aValue <> FMidiInOpen
      Then Begin
        If aValue
        Then
          With MidiInput
          Do Begin
            Open;
            Start;
            FMidiInOpen := True;
          End
        Else
          With MidiInput
          Do
            Try
              Stop;
            Finally
              Close;
              FMidiInOpen := False;
            End;
      End;
    End;

    Procedure   TFormServerMain.SetMidiOutOpen( aValue: Boolean);
    Begin
      If aValue <> FMidiOutOpen
      Then Begin
        If aValue
        Then MidiOutput.Open
        Else MidiOutput.Close;
        FMidiOutOpen := aValue;
      End;
    End;

    Procedure   TFormServerMain.SetBufferTime( aValue: Cardinal);
    Begin
      If aValue <> FBufferTime
      Then Begin
        FBufferTime := aValue;
        FMidiOutBuffer.BufferTime := FBufferTime;
      End;
    End;

    Procedure   TFormServerMain.SetBufferResolution( aValue: Cardinal);
    Begin
      If aValue <> FBufferResolution
      Then Begin
        FBufferResolution := aValue;
        FMidiOutBuffer.Resolution := FBufferResolution;
      End;
    End;

    procedure   TFormServerMain.SetPort( aValue: Integer);
    begin
      FPort := aValue;
      EditIpPort.Text := IntToStr( aValue);
    end;

    Procedure   TFormServerMain.SetIsServer( aValue: Boolean);
    Begin
      If FIsServer <> aValue
      Then Begin
        FIsServer := aValue;
        UpdateCaption;
      End;
    End;

    Procedure   TFormServerMain.SetIsConnected( aValue: Boolean);
    Begin
      If FIsConnected <> aValue
      Then Begin
        FIsConnected := aValue;
        UpdateCaption;
      End;
    End;

    procedure   TFormServerMain.SetServerName( const aValue: string);
    begin
      FServerName := aValue;
      EditServerName.Text := aValue;
    end;

    procedure   TFormServerMain.SetYourName( const aValue: string);
    begin
      FYourName := aValue;
      EditYourName.Text := aValue;
    end;

    Procedure   TFormServerMain.SetMonitoring ( aValue: Boolean);
    Begin
      If aValue <> FMonitoring
      Then Begin
        FMonitoring := aValue;
        CheckBoxMonitoring.Checked := FMonitoring;
      End;
    End;

    procedure   TFormServerMain.SetAutoStart( aValue: Boolean);
    begin
      FAutoStart := aValue;
      CheckBoxAutoStart.Checked := aValue;
    end;

    procedure   TFormServerMain.SetDisableNagle( aValue: Boolean);
    begin
      FDisableNagle := aValue;
      CheckBoxDisableNagle.Checked := aValue;
    end;

    Procedure   TFormServerMain.UpdateCaption;
    Const
      Titles : Array[ Boolean] Of String = (
        'Client',
        'Server'
      );
      Connects : Array[ Boolean, Boolean] Of String = (
        (
          'not connected',
          'connected'
        ),
        (
          'not listening',
          'listening'
        )
      );
      Buttons : Array[ Boolean, Boolean] Of String = (
        (
          'Connect',
          'Disconnect'
        ),
        (
          'Listen',
          'Disconnect all'
        )
      );
    Begin
      if not ( csDestroying in ComponentState)
      then begin
        Caption := Format( '%s - %s (%s)', [ FOrigCaption, Titles[ IsServer], Connects[ IsServer, IsConnected]]);
        Application.Title := Format( 'MC/P - %s', [ Titles[ IsServer]]);
        MenuItemConnect      .Caption := Buttons[ IsServer, IsConnected];
        SpeedButtonConnect   .Caption := Buttons[ IsServer, IsConnected];
        SpeedButtonDisconnect.Visible := IsServer;
      end;
    End;

    Procedure   TFormServerMain.LockConnectUpdates;
    Begin
      Inc( FLockConnectUpdates);
    End;

    Procedure   TFormServerMain.UnlockConnectUpdates;
    Begin
      If FLockConnectUpdates > 0
      Then Dec( FLockConnectUpdates);
      If FLockConnectUpdates = 0
      Then UpdateConnections;
    End;

    Procedure   TFormServerMain.MidiOutOverflow( aSender: TObject);
    Begin
      SignalOf;
    End;

    Procedure   TFormServerMain.MidiOutUnderflow( aSender: TObject);
    Begin
      SignalUf;
    End;

    Procedure   TFormServerMain.MidiOutComplete( aData: TData);
    Var
      aMidiEvent : TMyMidiEvent;
    Begin
      If MidiOutOpen
      Then Begin
        aMidiEvent := TMyMidiEvent.Create;
        With aData
        Do Begin
          aMidiEvent.SysexLength := Size;
          GetMem( aMidiEvent.Sysex, Size);
          Move( RawData^, aMidiEvent.Sysex^, Size);
        End;
        Try
          MidiOutput.PutMidiEvent( aMidiEvent);
        Except
          On Exception
          Do ;
        End;
        aMidiEvent.Free;
      End;
    End;

//  Private

    Procedure   TFormServerMain.ApplyChatSettings;
    begin
      YourName := EditYourName.Text;
      ChatChanged := False;
    end;

    Procedure   TFormServerMain.CancelChatSettings;
    begin
      EditYourName.Text := YourName;
      ChatChanged := False;
    end;

    Procedure   TFormServerMain.ApplyIpSettings;
    var
      WasConnected : Boolean;
      C            : Integer;
      aPort        : Integer;
    begin
      Val( EditIpPort.Text, aPort, C);
      If C = 0
      Then Begin
        WasConnected := IsConnected;
        DoConnect( False);
        Port         := aPort;
        IsServer     := CheckBoxIsServer    .Checked;
        ServerName   := EditServerName      .Text;
        AutoStart    := CheckBoxAutoStart   .Checked;
        DisableNagle := CheckBoxDisableNagle.Checked;
        DoConnect( WasConnected or AutoStart);
        IpChanged := False;
      End
      Else EditIpPort.SetFocus;
    end;

    Procedure   TFormServerMain.CancelIpSettings;
    begin
      EditIpPort          .Text    := IntToStr( Port);
      CheckBoxIsServer    .Checked := IsServer;
      EditServerName      .Text    := ServerName;
      CheckBoxAutoStart   .Checked := AutoStart;
      CheckBoxDisableNagle.Checked := DisableNagle;
      IpChanged := False;
    end;

    Procedure   TFormServerMain.ApplyMidiSettings;
    begin
      try
        BufferTime       := CheckCardinal( EditBufferTime);
        BufferResolution := CheckCardinal( EditBufferResolution);
        With ComboBoxInputs
        Do
          If ItemIndex >= 0
          Then Begin
            MidiIn := Items[ ItemIndex];
            If Not MidiInOpen
            Then MidiInOpen := MidiIn <> '';
          end
          Else MidiIn := '';
        With ComboBoxOutputs
        Do
          If ItemIndex >= 0
          Then Begin
            MidiOut := Items[ ItemIndex];
            If Not MidiOutOpen
            Then MidiOutOpen := MidiIn <> '';
          end
          Else MidiOut := '';
        MidiChanged := False;
      except
        on EAbort    // Kill aborts
        do;
        on Exception // Just kill exceptions as well
        do;
      end;
    end;

    Procedure   TFormServerMain.CancelMidiSettings;
    var
      i : Integer;
    begin
      With ComboBoxInputs
      Do Begin
        ItemIndex := -1;
        For i := 0 To Items.Count - 1
        Do
          If UpperCase( MidiIn) = UpperCase( Items[ i])
          Then Begin
            ItemIndex := i;
            Break;
          End;
      End;
      With ComboBoxOutputs
      Do Begin
        ItemIndex := -1;
        For i := 0 To Items.Count - 1
        Do
          If UpperCase( MidiOut) = UpperCase( Items[ i])
          Then Begin
            ItemIndex := i;
            Break;
          End;
      End;
      EditBufferTime      .Text := IntToStr( BufferTime      );
      EditBufferResolution.Text := IntToStr( BufferResolution);
      MidiChanged := False;
    end;

    Procedure   TFormServerMain.DoConnect( aValue: Boolean);
    Begin
      If aValue <> IsConnected
      Then Begin
        If aValue
        Then Begin
          SetIpSettings;
          If IsServer
          Then ServerSocket.Open
          Else ClientSocket.Open;
        End
        Else Begin
          If IsServer
          Then Begin
            ServerSocket.Close;
            IsConnected := False;
            ShowMonitorData( 'Server : ... deaf now');
            FConnections.Clear;
            UpdateConnections;
          End
          Else ClientSocket.Close;
        End;
      End;
    End;

    Procedure   TFormServerMain.SetNagleOption( aSock: TSocket);
    Var
      SockRes  : Integer;
      NoDelay  : LongBool;
    Begin
      NoDelay  := DisableNagle;
      SockRes  := setsockopt( aSock, IPPROTO_TCP, TCP_NODELAY, @ NoDelay, SizeOf( NoDelay));
      If SockRes <> 0
      Then Begin
        SockRes := WSAGetLastError;
        ShowMonitorDataFmt( 'Error ''%s'' setting Nagle''s algorithm''s use to %s', [ SocketErrorInfo( SockRes), BoolToStr( Not DisableNagle)]);
      End
      Else ShowMonitorDataFmt( 'Nagle''s algorithm used : %s', [ BoolToStr( Not DisableNagle)]);
    End;



    Procedure   TFormServerMain.HandleIpDecoded( aData: TData); // Virtual;
    Begin
      If Not ( csDesigning In ComponentState) And Not ( csDestroying In ComponentState)
      Then Begin
        Case aData.DataType Of
          dtTime : ShowTimeData( aData);
          dtMidi : ShowMidiData( aData);
          dtChat : ShowChatData( aData);
        End;
        SignalRx;
        ShowMonitorData( 'recv : ' + aData.AsDebugString);
        If IsServer
        Then
          Case aData.DataType Of
            dtMidi,
            dtChat  : SendIpData( aData);
          End;
      End;
    End;

    Procedure   TFormServerMain.SignalRx;
    Begin
      With TimerRx
      Do Begin
        Enabled := False;
        Enabled := True;
      End;
      PanelRx.Color := clYellow;
    End;

    Procedure   TFormServerMain.SignalTx;
    Begin
      With TimerTx
      Do Begin
        Enabled := False;
        Enabled := True;
      End;
      PanelTx.Color := clYellow;
    End;

    Procedure   TFormServerMain.SignalOf;
    Begin
      With TimerOf
      Do Begin
        Enabled := False;
        Enabled := True;
      End;
      PanelOf.Color := clYellow;
    End;

    Procedure   TFormServerMain.SignalUf;
    Begin
      With TimerUf
      Do Begin
        Enabled := False;
        Enabled := True;
      End;
      PanelUf.Color := clYellow;
    End;

    Procedure   TFormServerMain.ShowTimeData( aData: TData);
    Var
      DataCopy : TData;
    Begin
      DataCopy := TData.Create( 0);
      With DataCopy
      Do Begin
        RelativeTime := aData.RelativeTime;
        DataType     := dtMidi;
        FMidiOutBuffer.Push( DataCopy); // Keep timing Ok in midi scheduler.
      End;
    End;

    Procedure   TFormServerMain.ShowMidiData( aData: TData);
    Var
      DataCopy : TData;
    Begin
      If Assigned( FMidiOutBuffer)
      Then Begin
        DataCopy := TData.Create( 0);
        DataCopy.CopyFrom( aData);
        FMidiOutBuffer.Push( DataCopy);
      End;
    End;

    Procedure   TFormServerMain.SendTimeFiller;
    Var
      aData : TData;
    Begin
      aData := TData.Create( 0);
      With aData
      Do
        Try
          DataType := dtTime;
          SendIpData( aData);
        Finally
          Free;
        End;
    End;

    Procedure   TFormServerMain.ShowChatData( aData: TData);
    Begin
      // Show chat data in a chat window
      If aData.Count > 0
      Then Begin
        With aData
        Do VTermChat.WriteBuffer( RawData, Count);
        VTermChat.WriteLn( '');
      End;
    End;

    Procedure   TFormServerMain.SendIpData( aData: TData); // Virtual;
    Var
      i : Integer;
    Begin
      // Send data out over tcp/ip
      Try
        If Assigned( aData) and IsConnected
        Then Begin
          aData.RelativeTime := GetRelativeTime;
          ShowMonitorData( 'send : ' + aData.AsDebugString);
          aData.Encode;
          If IsServer
          Then Begin
            With ServerSocket.Socket
            Do
              For i := 0 To ActiveConnections - 1
              Do
                With Connections[ i] Do
                  If Connected
                  Then SendBuf( aData.RawData^, aData.Count)
          End
          Else
            With ClientSocket.Socket
            Do
              If Connected
              Then SendBuf( aData.RawData^, aData.Count);
          SignalTx;
        end;
      Except
        On Exception
        Do ;
      End;
    End;

    Procedure   TFormServerMain.DecodeIpData( aDecoder: TDecoder; aData: TData);
    Begin
      If Assigned( aDecoder)
      Then aDecoder.DecodeData( aData.Count, aData.RawData^);
    End;

    Procedure   TFormServerMain.SetIpSettings;
    Begin
      If IsConnected
      Then ShowMessage( 'Connected, can''t change settings now.')
      Else Begin
        With ClientSocket
        Do Begin
          If IsDottedIp( ServerName)
          Then Address := ServerName
          Else Host    := ServerName;
          Port := Self.Port;
        End;
        ServerSocket.Port := Port;
      End;
    End;

    Procedure   TFormServerMain.SendChatData( Const S: String); // Overload
    Var
      aData : TData;
    begin
      aData := TData.Create;
      With aData
      Do
        Try
          AddData( Length( S), PChar( S)^);
          DataType := dtChat;
          If IsServer // Local echo, for server only
          Then ShowChatData( aData);
          SendIpData( aData);
        Finally
          Free; // aData
        End;
    End;

    Procedure   TFormServerMain.SendChatDataFmt( Const aFormat: String; Const anArgs: Array Of Const);
    Begin
      SendChatData( Format( aFormat, anArgs));
    End;

    Procedure   TFormServerMain.SendChatData; // Overload
    Const
      CRLF = ^M^J;
    Var
      i : Integer;
      S : String;
    begin
      If MemoChatSend.Lines.Count > 0
      Then
        With MemoChatSend
        Do
          Try
            S := Format( '%s : ', [ YourName]);
            For i := 0 To Lines.Count - 1
            Do S := S + Lines[ i] + CRLF;
            SendChatData( S);
          Finally
            Clear; // MemoChatSend
          End;
    End;

    Procedure   TFormServerMain.ShowMonitorData( Const S: String);
    Begin
      If Monitoring and not ( csDestroying in ComponentState)
      Then VTermMonitor.WriteLn( S);
    End;

    Procedure   TFormServerMain.ShowMonitorDataFmt( Const S: String; Const aFormat: Array Of Const);
    Begin
      ShowMonitorData( Format( S, aFormat));
    End;

    Function    TFormServerMain.FormatConnectInfo( aSocket: TCustomWinSocket): String;
    Begin
      With aSocket
      Do Result := Format( '%s, %s : %d', [ RemoteHost, RemoteAddress, RemotePort]);
    End;

    Procedure   TFormServerMain.AddConnection( aSocket: TCustomWinSocket);
    Begin
      FConnections.Add( FormatConnectInfo( aSocket));
      UpdateConnections;
    End;

    Procedure   TFormServerMain.RemConnection( aSocket: TCustomWinSocket);
    Var
      i : Integer;
    Begin
      With FConnections
      Do Begin
        i := IndexOf( FormatConnectInfo( aSocket));
        If i >=0
        Then Delete( i);
      End;
      UpdateConnections;
    End;

    Procedure   TFormServerMain.UpdateConnections;
    Var
      i : Integer;
    Begin
      If FLockConnectUpdates = 0
      Then
        With ListBoxConnections
        Do Begin
          Items.Clear;
          With FConnections
          Do
            For i := 0 To Count - 1
            Do Items.Add( Strings[ i]);
        End;
    End;

    Procedure   TFormServerMain.DisConnectClient( Const aConnectInfo: String);
    Var
      i : Integer;
    Begin
      With ServerSocket.Socket Do
      Begin
        For i := 0 To ActiveConnections - 1
        Do
          If FormatConnectInfo( Connections[ i]) = aConnectInfo
          Then Connections[ i].Close;
      End;
    End;

    Function    TFormServerMain.GetRelativeTime: Word;
    Var
      aDelta : Int64;
      aTime  : DWord;
    Begin
      TimerMidi.Enabled := False;
      aTime  := TimeGetTime;
      aDelta := aTime - FStartTime;
      If ( aDelta > 65535) Or ( aDelta < 0)
      Then Result := 65535
      Else Result := aDelta;
      FStartTime := aTime;
      TimerMidi.Enabled := True;;
    End;

    Procedure   TFormServerMain.SaveIni; // Virtual;
    Begin
      With TIniFile.Create( IniFileName)
      Do
        Try
          EraseSection( 'Settings');
          WriteInteger( 'Settings', 'Left'            , Left            );
          WriteInteger( 'Settings', 'Top'             , Top             );
          WriteInteger( 'Settings', 'Width'           , Width           );
          WriteInteger( 'Settings', 'Height'          , Height          );
          WriteString ( 'Settings', 'MidiIn'          , FMidiIn         );
          WriteString ( 'Settings', 'MidiOut'         , FMidiOut        );
          WriteInteger( 'Settings', 'BufferTime'      , BufferTime      );
          WriteInteger( 'Settings', 'BufferResolution', BufferResolution);
          WriteInteger( 'Settings', 'Port'            , Port            );
          WriteBool   ( 'Settings', 'IsSever'         , IsServer        );
          WriteString ( 'Settings', 'ServerName'      , ServerName      );
          WriteBool   ( 'Settings', 'Monitoring'      , Monitoring      );
          WriteString ( 'Settings', 'YourName'        , YourName        );
          WriteBool   ( 'Settings', 'AutoStart'       , AutoStart       );
          WriteBool   ( 'Settings', 'DisableNagle'    , DisableNagle    );
        Finally
          Free;
        End;
    End;

    Procedure   TFormServerMain.LoadIni; // Virtual;
    Var
      L, T, W, H : Integer;
    Begin
      With TIniFile.Create( IniFileName)
      Do
        Try
          L                := ReadInteger( 'Settings', 'Left'            , Left            );
          T                := ReadInteger( 'Settings', 'Top'             , Top             );
          W                := ReadInteger( 'Settings', 'Width'           , Width           );
          H                := ReadInteger( 'Settings', 'Height'          , Height          );
          FPreMidiIn       := ReadString ( 'Settings', 'MidiIn'          , FPreMidiIn      );
          FPreMidiOut      := ReadString ( 'Settings', 'MidiOut'         , FPreMidiOut     );
          BufferTime       := ReadInteger( 'Settings', 'BufferTime'      , BufferTime      );
          BufferResolution := ReadInteger( 'Settings', 'BufferResolution', BufferResolution);
          Port             := ReadInteger( 'Settings', 'Port'            , Port            );
          IsServer         := ReadBool   ( 'Settings', 'IsSever'         , IsServer        );
          ServerName       := ReadString ( 'Settings', 'ServerName'      , ServerName      );
          Monitoring       := ReadBool   ( 'Settings', 'Monitoring'      , Monitoring      );
          YourName         := ReadString ( 'Settings', 'YourName'        , YourName        );
          AutoStart        := ReadBool   ( 'Settings', 'AutoStart'       , AutoStart       );
          DisableNagle     := ReadBool   ( 'Settings', 'DisableNagle'    , DisableNagle    );

          With Screen
          Do Begin
            If ( L < - 8) Or ( L > Width - 50)
            Then L := 0;
            If ( T < - 8) Or ( T > Height - 50)
            Then T := 0;
            If ( W < 20) Or ( W > Width + 16)
            Then W := 20;
            If ( H < 10) Or ( H > Height + 16)
            Then H := 10;
          End;
          Left   := L;
          Top    := T;
          Width  := W;
          Height := H;
        Finally
          Free;
        End;
    End;

// Delphi area

procedure TFormServerMain.MenuItemExitClick(Sender: TObject);
begin
  Close;
end;

procedure TFormServerMain.TimerRxTimer(Sender: TObject);
begin
  With TimerRx
  Do Enabled := False;
  PanelRx.Color := clBtnFace;
end;

procedure TFormServerMain.TimerTxTimer(Sender: TObject);
begin
  With TimerTx
  Do Enabled := False;
  PanelTx.Color := clBtnFace;
end;

procedure TFormServerMain.FormCreate(Sender: TObject);
begin
  FConnections := TStringList.Create;
  With FConnections
  Do Begin
    Sorted     := True;
    Duplicates := dupIgnore;
  End;

  FMidiOutBuffer := TTimedBuffer.Create( 1024);
  With FMidiOutBuffer
  Do Begin
    OnOverflow     := MidiOutOverflow;
    OnUnderflow    := MidiOutUnderflow;
    OnDataComplete := MidiOutComplete;
  End;

end;

procedure TFormServerMain.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  SaveIni;
  FreeAndNil( FMidiOutBuffer);
  MidiInOpen  := False;
  MidiOutOpen := False;
  ServerSocket.Close;
  ClientSocket.Close;
  FreeAndNil( FConnections);
end;

procedure TFormServerMain.MidiInputMidiInput(Sender: TObject);

Type

  MidiMsg = packed Record
    MSg : Byte;
    d1  : Byte;
    d2  : Byte;
  End;

  Function CombineBytes( aMsg, ad1, ad2: Byte): MidiMsg;
  Begin
    With Result
    Do Begin
      Msg := aMsg;
      d1  := ad1;
      d2  := ad2;
    End;
  End;

Var
  aMidiEvent : TMyMidiEvent;
  aMsg       : MidiMsg;
  aSize      : Byte;
  aData      : TData;
begin
  aData := Nil;
  With MidiInput
  Do Begin
    aMidiEvent := GetMidiEvent;
    Try
      With aMidiEvent
      Do Begin
        If SysExLength > 0
        Then aData := TData.Create( SysExLength, SysEx^)
        Else Begin
          Case ( MidiMessage And $f0) Shr 4 Of
            CProgramChange,
            CChannelPressure : aSize := 2;
            CSysEx : Begin
              Case MidiMessage And $0f Of
                SSongPosition : aSize := 3;
                SSongSelect   : aSize := 2;
                STuneRequest,
                SEox,
                STimingClock,
                SStart,
                SContinue,
                SStop,
                SActiveSense,
                SReset : aSize := 1;
                Else aSize := 0;
              End;
            End;
            Else aSize := 3;
          End;
          If aSize > 0
          Then Begin
            aMsg  := CombineBytes( MidiMessage, Data1, Data2);
            aData := TData.Create( aSize, aMsg);
          End;
        End;
      End;
    Finally
      aMidiEvent.Free;
    End;
  End;
  If Assigned( aData)
  Then Begin
    aData.DataType := dtMidi;
    Try
      SendIpData( aData);
    Finally
      aData.Free;
    End;
  End;
end;

procedure TFormServerMain.SpeedButtonClearMonitorClick(Sender: TObject);
begin
  VTermMonitor.ClearScreen;
end;

procedure TFormServerMain.SpeedButtonClearUpperChatClick(Sender: TObject);
begin
  MemoChatSend.Clear;
end;

procedure TFormServerMain.SpeedButtonClearLowerChatClick(Sender: TObject);
begin
  VTermChat.ClearScreen;
end;

procedure TFormServerMain.SpeedButtonSendChatClick(Sender: TObject);
begin
  SendChatData;
end;

procedure TFormServerMain.ClientSocketConnect(Sender: TObject;
  Socket: TCustomWinSocket);
Var
  aDecoder : TDecoder;
begin
  aDecoder := TDecoder.Create( 256);
  aDecoder.OnDataComplete := HandleIpDecoded;
  Socket.Data := aDecoder;
  IsConnected := True;
  ShowMonitorDataFmt( 'Connect : %s', [ FormatConnectInfo( Socket)]);
  SetNagleOption( Socket.SocketHandle);
  AddConnection( Socket);
end;

procedure TFormServerMain.ClientSocketDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  TDecoder( Socket.Data).Free;
  Socket.Data := Nil;
  IsConnected := False;
  ShowMonitorDataFmt( 'Disconnect : %s', [ FormatConnectInfo( Socket)]);
  RemConnection( Socket);
end;

procedure TFormServerMain.ClientSocketLookup(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  ShowMonitorDataFmt( 'Looking up host : %s', [ FormatConnectInfo( Socket)]);
end;

procedure TFormServerMain.ClientSocketConnecting(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  ShowMonitorDataFmt( 'Connecting to host : %s', [ FormatConnectInfo( Socket)]);
end;

procedure TFormServerMain.ClientSocketError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  With Socket Do
    ShowMonitorDataFmt( '** ** ** Socket error ''%s'' : ''%s''', [ SocketErrorInfo( ErrorCode), FormatConnectInfo( Socket)]);
  ErrorCode := 0;
end;

procedure TFormServerMain.ClientSocketRead(Sender: TObject;
  Socket: TCustomWinSocket);
Var
  aData : TData;
  aLen  : Integer;
begin
  SignalRx;
  With Socket
  Do Begin
    aLen := ReceiveLength;
    While aLen > 0
    Do Begin
      aData := TData.Create( aLen);
      aData.SetCount( aLen);
      ReceiveBuf( aData.RawData^, aData.Size);
      Try
        // As a side effect : show the decoded data as 'send : etc.'
        DecodeIpData( TDecoder( Data), aData);
      Finally
        aData.Free;
      End;
      aLen := ReceiveLength;
    End;
  End;
end;

procedure TFormServerMain.ServerSocketAccept(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  ShowMonitorDataFmt( 'Accepted %s, sent Welcome message.'   , [ FormatConnectInfo( Socket)]);
  SendChatDataFmt   ( 'Welcome to %s, you are connected now.', [ YourName                  ]);
end;

procedure TFormServerMain.ServerSocketClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
Var
  aDecoder : TDecoder;
begin
  ShowMonitorDataFmt( 'Client connect %s', [ FormatConnectInfo( Socket)]);
  SetNagleOption( Socket.SocketHandle);
  AddConnection( Socket);
  aDecoder := TDecoder.Create( 256);
  aDecoder.OnDataComplete := HandleIpDecoded;
  Socket.Data := aDecoder;
end;

procedure TFormServerMain.ServerSocketClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  TDecoder( Socket.Data).Free;
  Socket.Data := Nil;
  ShowMonitorDataFmt( 'Client disconnect %s', [ FormatConnectInfo( Socket)]);
  RemConnection( Socket);
end;

procedure TFormServerMain.ServerSocketClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  With Socket
  Do ShowMonitorDataFmt( '** ** ** Client socket error ''%s'' : ''%s''', [ SocketErrorInfo( ErrorCode), FormatConnectInfo( Socket)]);
  ErrorCode := 0;
end;

procedure TFormServerMain.ServerSocketClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
Var
  aData : TData;
  aLen  : Integer;
begin
  SignalRx;
  With Socket
  Do Begin
    aLen := ReceiveLength;
    While aLen > 0
    Do Begin
      aData := TData.Create( aLen);
      aData.SetCount( aLen);
      ReceiveBuf( aData.RawData^, aData.Size);
      Try
        // As a side effect : show the decoded data as 'send : etc.'
        DecodeIpData( TDecoder( Data), aData);
      Finally
        aData.Free;
      End;
      aLen := ReceiveLength;
    End;
  End;
end;

procedure TFormServerMain.ServerSocketListen(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  ShowMonitorData( 'Server : Starts Listening ...');
  IsConnected := True
end;

procedure TFormServerMain.MenuItemAboutClick(Sender: TObject);
begin
  FormAbout.ShowModal;
end;

procedure TFormServerMain.MenuItemConnectClick(Sender: TObject);
begin
  DoConnect( Not IsConnected);
end;

procedure TFormServerMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  If Shift = []
  Then Begin
    If ( Key = VK_RETURN) And MemoChatSend.Focused
    Then Begin
      SendChatData;
      Key := 0;
      Abort;
    End;
  End
  Else If Shift = [ ssAlt]
  Then Begin
    If Key = Word( 'X')
    Then Close;
  End;
end;

procedure TFormServerMain.CheckBoxMonitoringClick(Sender: TObject);
begin
  Monitoring := CheckBoxMonitoring.Checked;
end;

procedure TFormServerMain.SpeedButtonDisconnectClick(Sender: TObject);
Var
  i : Integer;
begin
  With ListBoxConnections
  Do
    With Items
    Do Begin
      LockConnectUpdates;
      Try
        For i := 0 To Count - 1
        Do
          If Selected[ i]
          Then
            If IsServer
            Then DisconnectClient( Items[ i])
            Else ClientSocket.Close;
      Finally
        UnlockConnectUpdates;
      End;
    End;
end;

procedure TFormServerMain.TimerMidiTimer(Sender: TObject);
begin
  SendTimeFiller;
end;

procedure TFormServerMain.VTermMonitorCursorMoved(aSender: TObject; aCol,
  aRow: Integer);
Var
  p : Integer;
begin
  With ScrollBoxMonitor
  Do Begin
    With HorzScrollBar
    Do Begin
      p := aCol * VTermMonitor.CharWidth - ScrollBoxMonitor.ClientWidth;
      If p < 0
      Then Position := 0
      Else Position := p;
    End;
    With VertScrollBar
    Do Begin
      p := ( aRow + 1) * VTermMonitor.LineHeight - ScrollBoxMonitor.ClientHeight;
      If p < 0
      Then Position := 0
      Else Position := p;
    End;
  End;
end;

procedure TFormServerMain.VTermMonitorDimChanged(aSender: TObject; aCol,
  aRow: Integer);
begin
  With ScrollBoxMonitor
  Do Begin
    With HorzScrollBar, VTermMonitor
    Do Begin
      Range := VTermMonitor.Width;
      If Not Smooth
      Then Increment := CharWidth;
    End;
    With VertScrollBar, VTermMonitor
    Do Begin
      Range := VTermMonitor.Height;
      If Not Smooth
      Then Increment := LineHeight;
    End;
  End;
end;

procedure TFormServerMain.FormResize(Sender: TObject);
begin
  With VTermMonitor
  Do Cols := ( ScrollBoxMonitor.ClientWidth Div CharWidth) - 2;
  With VTermChat
  Do Cols := ( ScrollBoxChat.ClientWidth Div CharWidth) - 2;
end;

procedure TFormServerMain.VTermChatCursorMoved(aSender: TObject; aCol,
  aRow: Integer);
Var
  p : Integer;
begin
  With ScrollBoxChat
  Do Begin
    With HorzScrollBar
    Do Begin
      p := aCol * VTermChat.CharWidth - ScrollBoxChat.ClientWidth;
      If p < 0
      Then Position := 0
      Else Position := p;
    End;
    With VertScrollBar
    Do Begin
      p := ( aRow + 1) * VTermChat.LineHeight - ScrollBoxChat.ClientHeight;
      If p < 0
      Then Position := 0
      Else Position := p;
    End;
  End;
end;

procedure TFormServerMain.VTermChatDimChanged(aSender: TObject; aCol,
  aRow: Integer);
begin
  With ScrollBoxChat
  Do Begin
    With HorzScrollBar, VTermChat
    Do Begin
      Range := VTermChat.Width;
      If Not Smooth
      Then Increment := CharWidth;
    End;
    With VertScrollBar, VTermChat
    Do Begin
      Range := VTermChat.Height;
      If Not Smooth
      Then Increment := LineHeight;
    End;
  End;
end;

procedure TFormServerMain.TimerOfTimer(Sender: TObject);
begin
  With TimerOf
  Do Enabled := False;
  PanelOf.Color := clBtnFace;
end;

procedure TFormServerMain.TimerUfTimer(Sender: TObject);
begin
  With TimerUf
  Do Enabled := False;
  PanelUf.Color := clBtnFace;
end;

procedure TFormServerMain.SpeedButtonConnectClick(Sender: TObject);
begin
  DoConnect( Not IsConnected);
end;

procedure TFormServerMain.FormShow(Sender: TObject);
begin
  InitMidi;
  FStartTime   := TimeGetTime;
  Caption      := 'M/CP';
  FOrigCaption := Caption;
  UpdateCaption;

  BufferTime       := 1000; // ms
  BufferResolution :=    5; // ms

  MemoChatSend.Clear;
  With VTermMonitor
  Do Begin
    ClearScreen;
    SetCursor( 0, 0);
  End;
  With VTermChat
  Do Begin
    ClearScreen;
    SetCursor( 0, 0);
  End;

  FMidiIn       := '';
  FMidiOut      := '';
  FPreMidiIn    := '';
  FPreMidiOut   := '';
  FIsServer     := True;
  IsServer      := False;
  FIsConnected  := True;
  IsConnected   := False;
  DisableNagle  := True;  // TCP Nagling off by default - better real time behaviour, maybe ...\


  LoadIni; // Reads FPreMidiXxx variables.

  Try
    MidiIn := FPreMidiIn; // FPreMidIn was read from the ini file.
  Except
    On E:Exception
    Do ShowMessageFmt( 'Could not open midi in port (%s) : %s', [ FPreMidiIn, E.Message]);
  End;
  Try
    MidiOut := FPreMidiOut; // FPreMidOut was read from the ini file.
  Except
    On E:Exception
    Do ShowMessageFmt( 'Could not open midi out port (%s) : %s', [ FPreMidiOut, E.Message]);
  End;

  Try
    MidiInOpen := MidiIn  <> '';
  Except
    On E:Exception
    Do ShowMessageFmt( 'Could not open midi in port (%s) : %s', [ FPreMidiIn, E.Message]);
  End;

  Try
    MidiOutOpen := MidiOut <> '';
  Except
    On E:Exception
    Do ShowMessageFmt( 'Could not open midi out port (%s) : %s', [ FPreMidiOut, E.Message]);
  End;

  If FAutoStart
  Then Begin
    SetIpSettings;
    DoConnect( True);
  End;

  With PageControlMain
  Do
    If IsServer
    Then ActivePage := TabsheetConnections
    Else ActivePage := TabSheetChat;

  CancelChatSettings;
  CancelIpSettings;
  CancelMidiSettings;
end;

procedure TFormServerMain.ChatSettingsChanged(Sender: TObject);
begin
  ChatChanged := True;
end;

procedure TFormServerMain.MidiSettingsChanged(Sender: TObject);
begin
  MidiChanged := True;
end;

procedure TFormServerMain.BitBtnApplyChatClick(Sender: TObject);
begin
  ApplyChatSettings;
end;

procedure TFormServerMain.BitBtnCancelChatClick(Sender: TObject);
begin
  CancelChatSettings;
end;

procedure TFormServerMain.BitBtnApplyIpClick(Sender: TObject);
begin
  ApplyIpSettings;
end;

procedure TFormServerMain.BitBtnCancelIpClick(Sender: TObject);
begin
  CancelIpSettings;
end;

procedure TFormServerMain.BitBtnApplyMidiClick(Sender: TObject);
begin
  ApplyMidiSettings;
end;

procedure TFormServerMain.BitBtnCancelMidiClick(Sender: TObject);
begin
  CancelMidiSettings;
end;

procedure TFormServerMain.IpSettingsChanged(Sender: TObject);
begin
  IpChanged := True;
end;

end.

